// mxdgio_dll.cpp : Defines the exported functions for the DLL application.
//
#include "stdafx.h"
#include "MxGeneralIo.h"
#include <windows.h>
#include <stdio.h>
#include "mxdgio.h"

typedef struct _DIO {
	int	port;
	int	data;
} DIO, *PDIO;

#define IO_ADDRESS_GP1X 0x300
#define IO_ADDRESS_GP2X 0x301
#define IO_ADDRESS_GP3X 0x302
#define IO_ADDRESS_GP4X 0x303
#define IO_ADDRESS_GP5X 0x304
#define IO_ADDRESS_GP6X 0x305

#define IO_BIT_GP14 4 //IO Address GP1X Bit 4
#define IO_BIT_GP15 5 //IO Address GP1X Bit 5

#define IO_BIT_GP20 0 //IO Address GP2X Bit 0
#define IO_BIT_GP21 1 //IO Address GP2X Bit 1
#define IO_BIT_GP22 2 //IO Address GP2X Bit 2
#define IO_BIT_GP23 3 //IO Address GP2X Bit 3
#define IO_BIT_GP24 4 //IO Address GP2X Bit 4
#define IO_BIT_GP25 5 //IO Address GP2X Bit 5
#define IO_BIT_GP26 6 //IO Address GP2X Bit 6

#define IO_BIT_GP30 0 //IO Address GP3X Bit 0
#define IO_BIT_GP31 1 //IO Address GP3X Bit 1
#define IO_BIT_GP32 2 //IO Address GP3X Bit 2
#define IO_BIT_GP33 3 //IO Address GP3X Bit 3
#define IO_BIT_GP37 7 //IO Address GP3X Bit 7

#define IO_BIT_GP40 0 //IO Address GP4X Bit 0
#define IO_BIT_GP45 5 //IO Address GP4X Bit 5

#define IO_BIT_GP56 6 //IO Address GP5X Bit 6


typedef struct _IOADDR_DEF {
    unsigned long IOAddress;
	 unsigned long DataBit;
  	 char *Desc;
} IOADDR_DEF;

#define DIO_HIGH			1
#define DIO_LOW				0

#define DEVICE_IO_TYPE		IO_TYPE_IOBASE
#define DIO_IO_ADDRESS		0x304
#define DIO_REMOTE_HARDWARE_RESET_ADDRESS	0x305

#define DIN_DATA_FILTER		0x3F
#define DOUT_DATA_FILTER	0x3

#define MAX_DOUT_PORT		8
#define MAX_DIN_PORT		8

IOADDR_DEF  DIN[] = {
                    {IO_ADDRESS_GP2X, IO_BIT_GP20,  "DIN0"}, // IOAddress, DataFilter, DataOffset, DataBit
                    {IO_ADDRESS_GP2X, IO_BIT_GP21,  "DIN1"}, //
                    {IO_ADDRESS_GP2X, IO_BIT_GP22,  "DIN2"}, //
                    {IO_ADDRESS_GP2X, IO_BIT_GP23,  "DIN3"}, //
                    {IO_ADDRESS_GP3X, IO_BIT_GP30, "DIN4"}, //
				 	  {IO_ADDRESS_GP3X, IO_BIT_GP31, "DIN5"}, //
					  {IO_ADDRESS_GP3X, IO_BIT_GP32,  "DIN6"}, //
                    {IO_ADDRESS_GP1X, IO_BIT_GP14, "DIN7"}
                    };

//IOADDR_DEF  DOUT[] = {
//                    {IO_ADDRESS_GP2X, IO_BIT_GP24, "DOUT0"}, //
//                    {IO_ADDRESS_GP2X, IO_BIT_GP25, "DOUT1"}, //
//                    {IO_ADDRESS_GP2X, IO_BIT_GP26, "DOUT2"}, //
//                    {IO_ADDRESS_GP1X, IO_BIT_GP15, "DOUT3"}, //
//                    {IO_ADDRESS_GP4X, IO_BIT_GP40,  "DOUT4"}, //
//					  {IO_ADDRESS_GP4X, IO_BIT_GP45,  "DOUT5"}, //
//					  {IO_ADDRESS_GP3X, IO_BIT_GP33,  "DOUT6"}, //
//                    {IO_ADDRESS_GP3X, IO_BIT_GP37,  "DOUT7"}
//                    };


IOADDR_DEF  DOUT[] = {
                    {IO_ADDRESS_GP2X, IO_BIT_GP24, "DOUT0"}, //
                    {IO_ADDRESS_GP2X, IO_BIT_GP25, "DOUT1"}, //
                    {IO_ADDRESS_GP2X, IO_BIT_GP26, "DOUT2"}, //
                    {IO_ADDRESS_GP1X, IO_BIT_GP15, "DOUT3"}, //
                    {IO_ADDRESS_GP5X, IO_BIT_GP56,  "DOUT4"}, //
					  {IO_ADDRESS_GP4X, IO_BIT_GP45,  "DOUT5"}, //
					  {IO_ADDRESS_GP3X, IO_BIT_GP33,  "DOUT6"}, //
                    {IO_ADDRESS_GP3X, IO_BIT_GP37,  "DOUT7"}
                    };



#ifdef __cplusplus    // If used by C++ code, 
extern "C" {          // we need to export the C interface
#endif


/*
	Initialize Digitial I/O
	
	param:
		None  :		
				
	Return value:
		HANDLE:			return digital I/O handle
*/
HANDLE mxdgio_open()
{
	BOOL bResult = FALSE;

	// Initialize WinIo
	bResult = MxGeneralIoOpen();
	if(bResult == FALSE)
	{
		printf("InitializeWinIo fail\n");
		return INVALID_HANDLE_VALUE;
	}

	return (HANDLE) 0;
}

/*
	get digital input
	
	param:
		(in)HANDLE hDIO  :	Handle of digital I/O		
				
	Return value:
		int:			return digital input data 
*/
int mxdgio_get_input_signal(HANDLE fd, int port)
{
	HANDLE	hDIO;
	int		inputSignal = 0;
	int		ret=0;
	DWORD	dwBackSize=0;
	DWORD	dwPortVal = 0;
	WORD	wPortAddr = (WORD)DIN[port].IOAddress;
	UCHAR	DataDIN = 0;
	BOOL	bResult;

	/*
	 * get data from register
	 *
	 */
	hDIO = fd;

	// 1.Check if any illegal parameter			
    if ( port < 0 || port > MAX_DIN_PORT ) {
		return (-1);
    }

	// 2. get register value (Call WinIo to get value)
	bResult = MxGetGeneralIoVal(DEVICE_IO_TYPE,wPortAddr, &dwPortVal, 1);
	if(bResult == FALSE)
	{
		return -1;
	}

	// 3.extract the specified digit
	DataDIN = (UCHAR)dwPortVal;
	if ( DataDIN & (1 << DIN[port].DataBit) )
    {
		inputSignal = DIO_HIGH;
	}
    else
    {
		inputSignal = DIO_LOW;
	}
		
	return inputSignal;
}

/*
	get digital output
	
	param:
		(in)HANDLE hDIO  :	Handle of digital I/O		
		(in)int port	 :	index of digital output			
	Return value:
		int:			return digital output data 
*/
int mxdgio_get_output_signal(HANDLE fd, int port)
{
	int		outputSignal = 0;
	int		ret=0;
	int		data = 0;
	BOOL	bResult;
	WORD	wPortAddr = (WORD)DOUT[port].IOAddress;
	UCHAR	DataDOUT = 0;
	DWORD	dwBackSize=0;
	DWORD	dwPortVal = 0;
	HANDLE	hDIO;
	
	/*
	 * get data from register
	 *
	 */
	hDIO = fd;

	// 1.Check if any illegal parameter			
    if ( port < 0 || port >= MAX_DOUT_PORT ) {
		return (-1);
    }

	// 2. get register value (Call WinIo to get value)
	bResult = MxGetGeneralIoVal(DEVICE_IO_TYPE, wPortAddr, &dwPortVal, 1);

	// 3.extract the specified digit
	DataDOUT = (UCHAR)dwPortVal;

	if ( DataDOUT & (1 << DOUT[port].DataBit) )
    {
		outputSignal = DIO_HIGH;
	}
    else
    {
		outputSignal = DIO_LOW;
	}

	return outputSignal;
}

/*
	set digital output
	
	param:
		(in)HANDLE fd  :	Handle of digital I/O		
		(in)int port	 :	index of digital output bit		
	
	Return value:
		BOOL:			TRUE indicates success, FALSE indicates failure.
*/
int mxdgio_set_output_signal_high(HANDLE fd, unsigned int port)
{
	int		retValue = 0;
	HANDLE	hDIO;
	int		data = 0;
	BOOL	bResult;
	WORD	wPortAddr = (WORD)DOUT[port].IOAddress;
	DWORD	dwPortVal = 0;
	DWORD	dwBackSize = 0;
	UCHAR	DataDOUT;
	
	/*
	 *	prepare the data to send
	 */
	hDIO = fd;

	//1.Check if any illegal parameter
    if ( port < 0 || port > MAX_DOUT_PORT ) {
			//printf("dio.port Error Error\n");
			return (-1);
    }

	// 2.Read current register value
	bResult = MxGetGeneralIoVal(DEVICE_IO_TYPE, wPortAddr, &dwPortVal, 1);

	// 3.Shift the data to lower bits
	DataDOUT = (UCHAR)dwPortVal;

	// 5.Prepare the value 
  	DataDOUT |= (1 << DOUT[port].DataBit);
   	
	// 6.set register 
	dwPortVal = DataDOUT;
	bResult = MxSetGeneralIoVal(DEVICE_IO_TYPE, wPortAddr, dwPortVal, 1);
	
	/*
	 * Wait for writing the data
	 */
	Sleep(50);
	
	if(bResult == FALSE)
	{
		retValue = (-1);
	}

	return retValue;
}

/*
	set digital output
	
	param:
		(in)HANDLE fd  :	Handle of digital I/O		
		(in)int port	 :	index of digital output bit		
		
	Return value:
		BOOL:			TRUE indicates success, FALSE indicates failure.
*/
int mxdgio_set_output_signal_low(HANDLE fd, unsigned int port)
{
	HANDLE	hDIO;
	//DIO		dio;

	DWORD	dwBackSize=0;
	int		ret=0;
	int		retValue = 0;
	WORD	wPortAddr = (WORD)DOUT[port].IOAddress;
	DWORD	dwPortVal = 0;
	UCHAR	DataDOUT;
	BOOL	bResult;
	
	/*
	 *	prepare the data to send
	 */
	hDIO = fd;
	
	//1.Check if any illegal parameter
    if ( port < 0 || port > MAX_DOUT_PORT ) {
			//printf("dio.port Error Error\n");
			return (-1);
    }

	// 2.Read current register value
	bResult = MxGetGeneralIoVal(DEVICE_IO_TYPE, wPortAddr, &dwPortVal, 1);

	// 3.Shift the data to lower bits
	DataDOUT = (UCHAR)dwPortVal;
	

	// 5.Prepare the value 
 	DataDOUT &= ~(1 << DOUT[port].DataBit);
 	
	// 6.set register
	dwPortVal = DataDOUT;
	bResult = MxSetGeneralIoVal(DEVICE_IO_TYPE, wPortAddr, dwPortVal, 1);
	
	/*
	 * Wait for writing the data
	 */
	Sleep(50);
	
	if(bResult == FALSE)
	{
		retValue = (-1);
	}

	return retValue;
}



/*
	close digital I/O
	
	param:
		(in)HANDLE hDIO  :	Handle of digital I/O		
				
	Return value:
		BOOL:			TRUE indicates success, FALSE indicates failure. 
*/
void mxdgio_close(HANDLE fd)
{
	if(fd != INVALID_HANDLE_VALUE)
	{
		//
		// Shut down 
		//
		
		/* Call MxGeneralIoClose to close the driver */
		MxGeneralIoClose();
	}
}

#ifdef __cplusplus    // If used by C++ code, 
}
#endif
